unit DSTR1;

interface

uses
  SysUtils, Classes, HTTPApp, DBWeb, DB, DBTables, HTTPProd, DSProd,Graphics;

type
  TWebModule1 = class(TWebModule)
    Table1: TTable;
    DataSetTableProducer1: TDataSetTableProducer;
    DataSetPageProducer1: TDataSetPageProducer;
    procedure WebModule1initialAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModule1defaultAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure DataSetTableProducer1FormatCell(Sender: TObject; CellRow,
      CellColumn: Integer; var BgColor: THTMLBgColor;
      var Align: THTMLAlign; var VAlign: THTMLVAlign; var CustomAttrs,
      CellData: String);
    procedure WebModule1fullAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
    procedure DataSetPageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure WebModule1PhotoAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}

procedure TWebModule1.WebModule1initialAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
    Response.Content:=DataSetTableProducer1.Content;
end;

procedure TWebModule1.WebModule1defaultAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
   Response.Content:='<H2> !</H2>';
   Response.Content:=Response.Content+'<a href=../dstr2.exe><h2></h2></a>';
end;

procedure TWebModule1.DataSetTableProducer1FormatCell(Sender: TObject;
  CellRow, CellColumn: Integer; var BgColor: THTMLBgColor;
  var Align: THTMLAlign; var VAlign: THTMLVAlign; var CustomAttrs,
  CellData: String);
begin
   if (CellRow>0)and(CellColumn=0) then
     Celldata:='<a href=dstr2.exe\full?EventNo='+
        table1.Fields[0].AsString+'>'+Celldata+'</A>';
end;

procedure TWebModule1.WebModule1fullAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
   q1:string;
   options:TLocateOptions;
begin
   q1:=Request.QueryFields.Values['EventNo'];
   Table1.Locate('EventNo',q1,options);
   Response.Content:=DataSetPageProducer1.Content;
end;

procedure TWebModule1.DataSetPageProducer1HTMLTag(Sender: TObject;
  Tag: TTag; const TagString: String; TagParams: TStrings;
  var ReplaceText: String);
begin
   if CompareText(TagString,'Event_Photo')=0 then
      ReplaceText:='<img src=Photo?EventNo='+table1.Fields[0].AsString+'>';
    if CompareText(TagString,'Event_Description')=0 then
      ReplaceText:=Table1.FieldByName('Event_Description').AsString;
end;

procedure TWebModule1.WebModule1PhotoAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  B:TBitmap;
  S:TMemoryStream;
  q1:string;
  options:TLocateOptions;
begin
   q1:=Request.QueryFields.Values['EventNo'];
   Table1.Locate('EventNo',q1,options);
   B:=TBitmap.Create;
   B.Assign(Table1.FieldByName('Event_Photo'));
   S:=TMemoryStream.Create;
   B.SaveToStream(S);
   S.Position:=0;
   Response.ContentType:='image/x-xbitmap';
   Response.ContentStream:=S;
   B.Free;
end;

end.
